enum { WIDTH = 40 , HEIGHT = 25 } ;
enum { LEFT = 0x41 , RIGHT = 0x44 , UP = 0x57 , DOWN = 0x53 } ;

void putpixel ( int x , int y , int color ) `0 image.pixel`

void tile ( int x , int y , int color ) {
   for ( int i = 1 ; i < 7 ; i ++ )
   for ( int j = 1 ; j < 7 ; j ++ )
      putpixel ( 8 * x + i , 8 * y + j , color ) ;
}

void initgraph ( ) { `0 image.show` `10 10 320 200 0 image.rect` }

int key = UP ;

void readkey ( ) { `key.code key !` `tib.clear` }

void initkeyb ( ) `use readkey to key.down`

int seed = - 1 ;
int rnd ( ) { return seed = seed * 128 ^ ( seed >> 11 ) ^ seed * 16 ; }

int snakex [ 1000 ] , snakey [ 1000 ] , targetx , targety , length , direction = UP ;

void box ( int x , int y , int w , int h , int c ) {
   for ( int j = y ; j < y + h ; j ++ )
   for ( int i = x ; i < x + w ; i ++ )
      tile ( i , j , c ) ;
}

void newtarget ( ) {
   int bit , i ;
   do {
      bit = 0 ;
      i = ( rnd ( ) & 0x3FF ) % ( ( WIDTH - 2 ) * ( HEIGHT - 2 ) ) ;
      targetx = 1 + i % ( WIDTH - 2 ) ;
      targety = 1 + i / ( WIDTH - 2 ) ;
      for ( i = 0 ; i < length ; ++ i )
         if ( targetx == snakex [ i ] &&
              targety == snakey [ i ] ) bit = 1 ;
   } while ( bit ) ;
   tile ( targetx , targety , 0x00FF00 ) ;
}

void init ( ) {
   box ( 0 , 0 , WIDTH , HEIGHT , 0x0000FF ) ;
   box ( 1 , 1 , WIDTH - 2 , HEIGHT - 2 , 0x000000 ) ;
   for ( length = 0 ; length < 6 ; ++ length )
      tile ( snakex [ length ] = WIDTH >> 1 , snakey [ length ] = HEIGHT - 7 + length , 0xFFFFFF ) ;
   direction = key = UP ;
   newtarget ( ) ;
}

void play ( ) {
   int i ;
   if ( ( ( key == LEFT )  && ( direction != RIGHT ) ) ||
        ( ( key == RIGHT ) && ( direction != LEFT  ) ) ||
        ( ( key == UP )    && ( direction != DOWN  ) ) ||
        ( ( key == DOWN )  && ( direction != UP )  ) ) direction = key ;
   tile ( snakex [ length - 1 ] , snakey [ length - 1 ] , 0x000000 ) ;
   for ( i = length - 1 ; i > 0 ; -- i ) {
      snakex [ i ] = snakex [ i - 1 ] ;
      snakey [ i ] = snakey [ i - 1 ] ;
   }
   if ( direction == LEFT )  -- snakex [ 0 ] ; else
   if ( direction == RIGHT ) ++ snakex [ 0 ] ; else
   if ( direction == UP )    -- snakey [ 0 ] ; else
   if ( direction == DOWN )  ++ snakey [ 0 ] ;
   tile ( snakex [ 0 ] , snakey [ 0 ] , 0xFFFFFF ) ;
   if ( snakex [ 0 ] < 1 || snakex [ 0 ] >= WIDTH - 1 ||
        snakey [ 0 ] < 1 || snakey [ 0 ] >= HEIGHT - 1 ) init ( ) ;
   for ( i = 1 ; i < length ; ++ i )
      if ( snakex [ 0 ] == snakex [ i ] &&
           snakey [ 0 ] == snakey [ i ] ) init ( ) ;
   if ( snakex [ 0 ] == targetx && snakey [ 0 ] == targety ) {
      snakex [ length ] = snakex [ length - 1 ] ;
      snakey [ length ] = snakey [ length - 1 ] ;
      ++ length ;
      newtarget ( ) ;
   }
}

void scene ( ) { `0 image.hide` play ( ) ; `0 image.show` }

void inittimer ( ) { `150 timer.interval` `use scene to timer` }

void main ( ) {
   initgraph ( ) ;
   initkeyb ( ) ;
   init ( ) ;
   inittimer ( ) ;
}
